
var types = require("enjoy-typechecks");
var auto = require("./auto");

function eachInArray (fn, collection) {
    [].forEach.call(collection, fn);
}

function eachInObject (fn, collection) {
    Object.keys(collection).forEach(function (key) {
        fn(collection[key], key, collection);
    });
}

function each (fn, collection) {
    return types.isArrayLike(collection) ?
        eachInArray(fn, collection) :
        eachInObject(fn, collection);
}

module.exports = auto(each);
